VMware: booting compute node with no hosts in cluster causes an exception

Bug #1383305 reported by Gary Kotton on 2014-10-20
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
OpenStack Compute (nova)
Critical
Gary Kotton
Juno
Undecided
Unassigned

Bug Description

2014-10-20 06:23:38.107 CRITICAL nova [-] AttributeError: 'Text' object has no attribute 'ManagedObjectReference'

2014-10-20 06:23:38.107 TRACE nova Traceback (most recent call last):
2014-10-20 06:23:38.107 TRACE nova File "/usr/local/bin/nova-compute", line 10, in <module>
2014-10-20 06:23:38.107 TRACE nova sys.exit(main())
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/cmd/compute.py", line 72, in main
2014-10-20 06:23:38.107 TRACE nova db_allowed=CONF.conductor.use_local)
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/service.py", line 275, in create
2014-10-20 06:23:38.107 TRACE nova db_allowed=db_allowed)
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/service.py", line 148, in __init__
2014-10-20 06:23:38.107 TRACE nova self.manager = manager_class(host=self.host, *args, **kwargs)
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/compute/manager.py", line 633, in __init__
2014-10-20 06:23:38.107 TRACE nova self.driver = driver.load_compute_driver(self.virtapi, compute_driver)
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/virt/driver.py", line 1385, in load_compute_driver
2014-10-20 06:23:38.107 TRACE nova virtapi)
2014-10-20 06:23:38.107 TRACE nova File "/usr/local/lib/python2.7/dist-packages/oslo/utils/importutils.py", line 50, in import_object_ns
2014-10-20 06:23:38.107 TRACE nova return import_class(import_value)(*args, **kwargs)
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/virt/vmwareapi/driver.py", line 186, in __init__
2014-10-20 06:23:38.107 TRACE nova self._update_resources()
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/virt/vmwareapi/driver.py", line 381, in _update_resources
2014-10-20 06:23:38.107 TRACE nova self.dict_mors.get(node)['cluster_mor'])
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/virt/vmwareapi/host.py", line 50, in __init__
2014-10-20 06:23:38.107 TRACE nova self.update_status()
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/virt/vmwareapi/host.py", line 63, in update_status
2014-10-20 06:23:38.107 TRACE nova self._cluster)
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/virt/vmwareapi/host.py", line 34, in _get_ds_capacity_and_freespace
2014-10-20 06:23:38.107 TRACE nova ds = ds_util.get_datastore(session, cluster)
2014-10-20 06:23:38.107 TRACE nova File "/opt/stack/nova/nova/virt/vmwareapi/ds_util.py", line 254, in get_datastore
2014-10-20 06:23:38.107 TRACE nova data_store_mors = datastore_ret.ManagedObjectReference
2014-10-20 06:23:38.107 TRACE nova AttributeError: 'Text' object has no attribute 'ManagedObjectReference'
2014-10-20 06:23:38.107 TRACE nova
n-cpu failed to start

Gary Kotton (garyk) wrote :

This is critical as the compute node will not start. This is a regression from H

Changed in nova:
assignee: nobody → Gary Kotton (garyk)
importance: Undecided → Critical

Fix proposed to branch: master
Review: https://review.openstack.org/129616

Changed in nova:
status: New → In Progress
Gary Kotton (garyk) on 2014-10-20
tags: added: juno-backport-potential vmware

Reviewed: https://review.openstack.org/129616
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=419096ec19cc3538243c232d781a5ca6205475ea
Submitter: Jenkins
Branch: master

commit 419096ec19cc3538243c232d781a5ca6205475ea
Author: Gary Kotton <email address hidden>
Date: Mon Oct 20 06:37:14 2014 -0700

    VMware: fix compute node exception when no hosts in cluster

    Commit 4033c0c9c16d2844b36fd5627717e7ce206887f6 casues the
    regression. The result was a empty string and not None.
    That is suds returns a Text object and not None.

    Change-Id: I79e70e300f40eb3561cf56478d578f0f8cda273e
    Closes-bug: #1383305

Changed in nova:
status: In Progress → Fix Committed
Thierry Carrez (ttx) on 2014-12-18
Changed in nova:
milestone: none → kilo-1
status: Fix Committed → Fix Released

Reviewed: https://review.openstack.org/131951
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=4dd50808bf32ef1f596af53f6263c5eb724f8cc6
Submitter: Jenkins
Branch: stable/juno

commit 4dd50808bf32ef1f596af53f6263c5eb724f8cc6
Author: Gary Kotton <email address hidden>
Date: Mon Oct 20 06:37:14 2014 -0700

    VMware: fix compute node exception when no hosts in cluster

    Commit 4033c0c9c16d2844b36fd5627717e7ce206887f6 casues the
    regression. The result was a empty string and not None.
    That is suds returns a Text object and not None.

    Change-Id: I79e70e300f40eb3561cf56478d578f0f8cda273e
    Closes-bug: #1383305
    (cherry picked from commit 419096ec19cc3538243c232d781a5ca6205475ea)

tags: added: in-stable-juno
Thierry Carrez (ttx) on 2015-04-30
Changed in nova:
milestone: kilo-1 → 2015.1.0
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers